unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, OoMisc, AdPort, Spin, ComCtrls, Buttons,
  rmAGraph;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    btnRun: TButton;
    Shape1: TShape;
    ApdComPort1: TApdComPort;
    ListBox1: TListBox;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    rmAGraph1: TrmAGraph;
    procedure btnRunClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    TLC1543Values: array[0..13] of integer;
    procedure ResetHard;
    procedure WriteAddr(state: boolean);
    procedure WriteCLK(state: boolean);
    function ReadDataBit: boolean;
    function ReadEOC: boolean;
    procedure ReadTLC1543Values;
    procedure AddTLC1543ValuesToGraph;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses
  rmMisc;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with rmAGraph1 do begin
    VertUnit := '';
    MaxItems := width - LeftMargin - RightMargin;
  end;
  TrackBar1Change(nil);
  ResetHard;
end;

procedure TForm1.ResetHard;
begin
end;

procedure TForm1.WriteAddr(state: boolean);
begin
  ApdComPort1.RTS := not state;
end;

procedure TForm1.WriteCLK(state: boolean);
begin
  ApdComPort1.DTR := not state;
end;

function TForm1.ReadDataBit: boolean;
begin
  result := not apdComPort1.CTS;
end;

function TForm1.ReadEOC: boolean;
begin
  result := not apdComPort1.DSR;
end;

procedure TForm1.btnRunClick(Sender: TObject);
begin
  if btnRun.caption = 'Start' then begin
    Shape1.Brush.Color := clRed;
    ResetHard;
    timer1.Enabled := true;
    Shape1.Brush.Color := clLime;
    btnRun.caption := 'Stop';
  end else if btnRun.caption = 'Stop' then begin
    timer1.Enabled := false;
    Shape1.Brush.Color := clGray;
    btnRun.caption := 'Start';
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if Shape1.Brush.Color = clGray then
    Shape1.Brush.Color := clLime
  else
    Shape1.Brush.Color := clGray;
  ReadTLC1543Values;
  AddTLC1543ValuesToGraph;
end;

procedure TForm1.ReadTLC1543Values;
var
  i, j, temp: integer;
  addr: string[4];
  val: integer;
  EOC: boolean;
  timeOut: integer;
  t: longInt;
begin
  timeOut := 20;

  for i := 0 to 13 do begin

    // adresse de l'entre  lire
    addr := byteToBits(i, 4);

    // rcupration des valeurs chantillonnes par le TLC1543
    temp := 1024;
    val := 0;
    for j := 1 to 10 do begin
      temp := temp div 2;
      if j < 5 then
        WriteAddr(copy(Addr, j, 1) = '1')                 // via RTS
      else
        WriteAddr(false);                                 // via RTS
      WriteCLK(true);  // front montant de l'horloge      // via DTR
      if ReadDataBit then val := val + temp;              // via CTS
      WriteCLK(false); // front descendant de l'horloge   // via DTR
    end;

    // wait for End Of Conversion
    t := GetTickCount;
    repeat
      EOC := ReadEOC;                                      // via DSR
    until EOC or (GetTickCount > (t + timeOut));

    // stockage dans le tableau des valeurs
    case i of
      0 : TLC1543Values[13] := val;
      1..13 : TLC1543Values[i - 1] := val;
    end;

  end;
end;

procedure TForm1.AddTLC1543ValuesToGraph;
var
  i: integer;
  s: string;
begin
  s := '';
  for i := 10 to 13 do
    s := s + intToStr(TLC1543Values[i]) + ';';
  rmAGraph1.AddValues(s, true);

  // affichage des valeurs dans une TListbox, pour vrif
  ListBox1.Clear;
  for i := 0 to 13 do begin
    s := byteToBits(i, 4) + ' --> ' + intToStr(TLC1543Values[i]);
    ListBox1.items.add(s);
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  timer1.Interval := TrackBar1.Position;
  label1.Caption := intToStr(TrackBar1.Position) + ' ms';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  OKForClose: boolean;
begin
  OKForClose := not timer1.Enabled;
  if not OKForClose then
  begin
    showmessage('Acquisition en cours !');
    CanClose := false;
  end else begin
    CanClose := true;
  end;
end;

end.
